#ifndef lint
static const char rcsid[] =
    "@(#) $Id: munge.c 54 2010-05-12 00:47:45Z leres $ (LBL)";
#endif

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdlib.h>

#include "fit.h"
#include "version.h"

#define MAXDATA 64

/* TODO: use malloc() and realloc() */
/* TODO: add -v to print out data as its read */
/* TODO: read for a named file */

/* Forwards */
int main(int, char **);
void usage(void) __attribute__((noreturn));
int getpair(double *, double *);

int
main(int argc, char **argv)
{
	double x[MAXDATA], y[MAXDATA], a, b, r;
	int ndata;

	for (ndata = 0; getpair(&x[ndata], &y[ndata]); ndata++)
		if (ndata >= MAXDATA - 1) {
			(void) fprintf(stderr,
			    "munge: Too many points (%d max)\n", MAXDATA);
			exit(1);
		}

	fit(x, y, ndata, &a, &b, &r);

	(void) printf("a %f\tb %f\tr %f\n", a, b, r);
	exit(0);
}

int
getpair(double *x, double *y)
{
	char buf[512];
	char *cp;

	if (fgets(buf, sizeof(buf), stdin) == 0)
		return(0);
	cp = buf;
	while (isspace(*cp))
		cp++;
	*x = atof(cp);
	while (!isspace(*cp))
		cp++;
	if (*cp == '\n' || !isspace(*cp)) {
		(void) fprintf(stderr, "munge: can't parse \"%s\"\n", buf);
		exit(1);
	}
	*y = atof(cp);
	return(1);
}
